/* raddic: a curses program for finding kanji radicals */

/* Copyright (C) 1996 Ben Kasmin Bullock  */

/* raddic is free software; you can redistribute it and/or modify it under */
/* the terms of the GNU General Public License as published by the Free */
/* Software Foundation; either version 2, or (at your option) any later */
/* version. */

/* raddic is distributed in the hope that it will be useful, but WITHOUT */
/* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or */
/* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License */
/* for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with raddic; see the file COPYING.  If not, write to the Free */
/* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA */
/*  02111-1307, USA. */



%{

/* kanji_sort.l : Ben Bullock : April 25th 1994 */

#include <stdio.h>
#include <string.h>

FILE *kanjis;

char k[2];
int total=0;
int rad;
char str[2];

void kout();

%}

kanji		[\260-\377][\200-\377]
hiragana	\244[\200-\377]
katakana	\245[\200-\377]
number  [0-9]+

%%
{kanji}		{k[0]=yytext[0];k[1]=yytext[1];}
" B"{number}" C"{number}" S"{number}" "  { /* there are two radical numbers */
  rad=atoi(yytext+2);
  kout();
  rad=atoi(strchr(yytext,'C')+1);
  kout();
}
" B"{number}" S"{number}" "	      { /* there is only one radical number */
  rad=atoi(yytext+2);
  kout();
}
%%

main()
{
  if ((kanjis=fopen("kanjis","w"))==NULL) {
    fprintf(stderr,"Failed to open output dictionary.  Exiting.");
    exit(1);
  }
  while(yylex());
  fprintf(kanjis,"};\n#define KANJIS %d\n",total);
  fclose(kanjis);
  exit(0);
}

void kout()

{
  str[0]=*(strchr(yytext,'S')+1);
  str[1]=*(strchr(yytext,'S')+2);
  fprintf(kanjis,"{\"%c%c\",%d,%c%c},\n",
	  k[0],k[1],rad,str[0],str[1]);
  total++;
}
